*#cpu 8086 Rom
*
* DDS MICRO-C Runtime library for: 8086 Family (standalone)
* Special ROM model!
*
* Copyright 1988-2005 Dave Dunfield
* All rights reserved.
*
	MOV	AX,#$8000	RAM DATA segment
	MOV	SS,AX		Set up SS
	MOV	SP,#$FFFE	Initial stack pointer
	MOV	ES,AX		Set up ES
* Copy initialized data to RAM
	PUSH	CS		Get code segment
	POP	DS		DataSeg = CodeSeg
	MOV	SI,#?Ivars	Point to variables
	XOR	DI,DI		RAMseg begins at zero
	MOV	CX,#?Isize	Get size of inited variables
	REP			Repeat prefix
	MOVSB			Copy initialized storage
* Zero unitialized RAM area
* NOTE: Following code relies on DI state after preceeding MOVSB
	MOV	DS,AX		Reset DS
	XOR	AL,AL		Zero AL
	MOV	CX,#?heap+1-?temp Get size on uninited data (Incl ?heap)
	REP			Repeat prefix
	STOSB			Zero uninitialized storage
	CALL	main		Execute main program
exit	JMP	<exit		Loop forever
* Compare library routines
?eq	CMP	AX,CX		CX == AX
	JZ	TRUE
	XOR	AX,AX
	RET
?ne	CMP	AX,CX		CX != AX
	JNZ	TRUE
	XOR	AX,AX
	RET
?lt	CMP	AX,CX		CX < AX
	JG	TRUE
	XOR	AX,AX
	RET
?le	CMP	AX,CX		CX <= AX
	JGE	TRUE
	XOR	AX,AX
	RET
?gt	CMP	AX,CX		CX > AX
	JL	TRUE
	XOR	AX,AX
	RET
?ge	CMP	AX,CX		CX >= AX
	JLE	TRUE
	XOR	AX,AX
	RET
?ult	CMP	AX,CX		CX < AX (unsigned)
	JA	TRUE
	XOR	AX,AX
	RET
?ule	CMP	AX,CX		CX <= AX (unsigned)
	JAE	TRUE
	XOR	AX,AX
	RET
?ugt	CMP	AX,CX		CX > AX (unsigned)
	JB	TRUE
	XOR	AX,AX
	RET
?uge	CMP	AX,CX		CX >= AX (unsigned)
	JBE	TRUE
FALSE	XOR	AX,AX
	RET
* logically negate (ax)
?not	AND	AX,AX		Test for non-zero
	JNZ	FALSE		Not zero, invert
TRUE	MOV	AX,#1		Create a true value
	AND	AX,AX		Set condition code
nargs	RET
* Handle switch statement
?switch	MOV	CX,CS:[BX]	Get label value
	JCXZ	SWEND		End of table - Special case
	ADD	BX,#4		Skip to next
	CMP	AX,CS:-2[BX]	Does it match?
	JNZ	?switch		No, keep looking
	JMP	CX		Execute case code
SWEND	JMP	CS:2[BX]	Execute default code
$SE:1
*#map1 Segment 1 - Initialized storage tables
*
?Ivars	EQU	*
$SE:2
?Isize	EQU	*-?Ivars
*#map2 Segment 2 - Data storage area
*
* NOTE: If for some reason, you don't begin your data at offset 0,
* adjust the following 'ORG', and replace the XOR DI,DI near the
* beginning of this file with a load of the proper offset.
*
	ORG	$0000		Begin data at offset 0 in segment
$DD:?temp 2
