*
* Test for ASCII character
*
isascii	MOV	AX,#$007F	Range to test
	JMP	<?1		Perform test
*
* Test for alphanumeric character (0-9, A-Z, a-z)
*
isalnum	POP	CX		CX = ret address
	CALL	isdigit		Number?
	JE	?5		No, its not
?4	JMP	CX		Return to caller
*
* Test for alphabetic character (A-Z, a-z)
*
isalpha	POP	CX		CX = ret address
?5	CALL	isupper		Uppercase?
	JNE	?4		Yes, we have it
	PUSH	CX		Restore ret address
*
* Test for lowercase alphabetic character (a-z)
*
islower	MOV	AX,#'az'	Range to test
	JMP	<?1		Perform test
*
* Test for uppercase alphabetic character (A-Z)
*
isupper	MOV	AX,#'AZ'	Range to test
	JMP	<?1		Perform test
*
* Test for graphic (printable) character
*
isgraph	MOV	AX,#$217E	Range to test
	JMP	<?1		And proceed
*
* Test for HEX digit
*
isxdigit POP	CX		CX = ret address
	MOV	AX,#'AF'	Test range
	CALL	?1		Test it
	JNE	?4		Found it
	MOV	AX,#'af'	Test range
	CALL	?1		Test it
	JNE	?4		Found it
	PUSH	CX		Restore ret address
*
* Test for an ASCII digit (0-9)
*
isdigit	MOV	AX,#'09'	Range to test
* Test argument against range in A:B
?1	MOV	BX,SP		Address stack
	CMP	AL,2[BX]	Test LOWER limit
	JB	?3		Failed, return FALSE
	CMP	AH,2[BX]	Test UPPER limit
	JA	?3		Failed return FALSE
* Test that upper byte of argument is zero
?2	MOV	AH,3[BX]	Get high byte
	AND	AH,AH		Zero?
	JNZ	?3		Non-zero, fail
	MOV	AL,#1		Return 1
	AND	AL,AL		Clear Z
	RET
* Report failure, return FALSE (0)
?3	XOR	AX,AX		Return zero
	RET
*
* Test for CONTROL character
*
iscntrl	MOV	BX,SP		Address stack
	MOV	AL,2[BX]	Get argument
	CMP	AL,#$7F		Delete?
	JZ	?2		Yes, test high
	MOV	AX,#$001F	CTRL-range
	JMP	<?1		Complete test
*
* Test for a punctuation character
*
ispunct	MOV	BX,SP		Address stack
	MOV	AX,2[BX]	Get argument
	PUSH	AX		Pass it on
	CALL	isalnum		Alphanumeric?
	POP	BX		Clean up
	JNE	?3		Yes, false
*
* Test for printable character
*
isprint	MOV	AX,#$207E	Printable range
	JMP	<?1		And test for it
*
* Test for a "space" character
*
isspace	MOV	BX,SP		Address stack
	MOV	AX,2[BX]	Get argument
	CMP	AL,#' '		Space?
	JZ	?2		Seems OK
	CMP	AL,#9		Tab?
	JZ	?2		Seems OK
	CMP	AL,#10		Newline?
	JZ	?2		Seems OK
	JMP	<?3		Invalid
